program DosDoor_3;
{$M $9000, 0, 0}
uses crt, dos, miscproc, miscfunc, xdoor;

var ddOrigDir : string[255];

procedure ddInit;
  var i : byte;
      f1 : text;
      s : string[255];
  begin
    cfgName := 'DosDoor.cfg'; { set the misc xDoor stuff }
    doorName := 'DosDoor v3.0';
    useStatus := true;
    statusBg := 4;
    statusDark := 12;
    statusNormal := 12;
    statusBright := 12;
    initDoor;
    getdir(0, ddOrigDir); { set the starting dir, returns here at exit }
    for i := 1 to 15 do ddCmdBuf[i] := ''; { initialize the command buffer }
    assign(f1, cfgName);
    {$I-} reset(f1); {$I+}
    if (ioResult <> 0) then begin
      writeln(cfgName + ' not found.');
      writeln;
      halt;
    end;
    for i := 1 to 4 do readln(f1, s);
    readln(f1, ddCEXYZ); { get the location of CE-XYZ }
    close(f1);
    ddDone := false; { DosDoor isn't done }
    color(7, 0);
    cClrScr;
  end;

procedure enterDosDoor;
  var cmdString : string[255];
  begin
    repeat
      drawPrompt;
      cmdString := ddInstr('', 255);
      processCmd(cmdString);
    until ddDone;
  end;

begin
  ddInit;
  ddVersion;
  enterDosDoor;
  chdir(ddOrigDir);
end.