unit miscFunc;

interface

var ddCmdBuf : array[1..15] of string[255];
    ddCEXYZ : string[255];
    ddDone : boolean;

function doTime(hour, min, sec : byte) : string;
function getToken(aString, sepChar : string; tokenNum : byte):string;
function getVol(drive : char):string;
function isDir(s : string) : boolean;
function itos(i : longint):string;
function leadZero(i : longint) : string;
function leftStr(s : string; b : byte) : string;
function numToken(aString, sepChar : string) : byte;
function padb(s : string; b : byte):string;
function padf(s : string; b : byte):string;
function upString(s : string) : string;
Function ddInstr(defString: String; Len: Byte): String;

implementation

uses crt, dos, xdoor, miscproc;

function doTime(hour, min, sec : byte) : string;
  var am : boolean;
      s : string;
  begin
    if (hour > 11) then am := false
    else am := true;
    if (hour > 12) then hour := hour - 12;
    if (hour = 0) then hour := 12;
    s := leadZero(hour) + ':' + leadZero(min);
    if (am) then s := s + 'a'
    else s := s + 'p';
    doTime := s;
  end;

function getToken(aString, sepChar : string; tokenNum : byte):string;
  var
    token : string;
    strLen, tNum, tEnd : byte;
  begin
    strLen := length(aString);
     TNum   := 1;
     TEnd   := StrLen;
     while ((TNum <= TokenNum) and (TEnd <> 0)) do
     begin
          TEnd := Pos(SepChar,aString);
          if TEnd <> 0 then
          begin
               Token := Copy(aString,1,TEnd-1);
               Delete(aString,1,TEnd);
               Inc(TNum);
          end
          else
          begin
               Token := aString;
          end;
     end;
     if TNum >= TokenNum then
     begin
          GetToken := Token;
     end
     else
     begin
          GetToken := '';
     end;
end;

function getVol(drive : char):string;
  var sr : searchRec;
      volLabel : string;
  begin
    findfirst(drive + ':\*.*', volumeID, sr);
    if dosError=0 then getVol := sr.name
    else getVol := '';
  end;

function isDir(s : string) : boolean;
  var f1 : file;
      attr : word;
  begin
    assign(f1, s);
    getfattr(f1, attr);
    if (attr = directory) then isDir := true
    else isDir := false;
  end;

function itos(i : longint):string;
  var s : string;
  begin
    str(i, s);
    itos := s;
  end;

function leadZero(i : longint) : string;
  var s : string;
  begin
    s := itos(i);
    if (length(s) = 1) then s := '0' + s;
    leadZero := s;
  end;

function leftStr(s : string; b : byte) : string;
  begin
    delete(s, b+1, length(s));
    leftStr := s;
  end;

function numToken(aString, sepChar : string) : byte;
var
   RChar     : Char;
   StrLen    : Byte;
   TNum      : Byte;
   TEnd      : Byte;

begin
     if SepChar = '#' then
     begin
          RChar := '*'
     end
     else
     begin
         RChar := '#'
     end;
     StrLen := Length(aString);
     TNum   := 0;
     TEnd   := StrLen;
     while TEnd <> 0 do
     begin
          Inc(TNum);
          TEnd := Pos(SepChar,aString);
          if TEnd <> 0 then
          begin
               aString[TEnd] := RChar;
          end;
     end;
     NumToken := TNum;
end;

function padb(s : string; b : byte):string;
  var i : byte;
  begin
    if (length(s) < b) then for i := 1 to (b - length(s)) do s := s + ' ';
    padb := s;
  end;

function padf(s : string; b : byte):string;
  var i : byte;
  begin
    if (length(s) < b) then for i := 1 to (b - length(s)) do s := ' ' + s;
    padf := s;
  end;

function upString(s : string) : string;
  var b : byte;
  begin
    for b := 1 to length(s) do s[b] := upcase(s[b]);
    upString := s;
  end;

function ftrim(s : string) : string;
  var done : boolean;
  begin
    done := false;
    repeat
      if (s[1] = ' ') then delete(s, 1, 1)
      else done := true;
    until done;
    done := false;
    repeat
      if (s[length(s)] = ' ') then delete(s, length(s), 1)
      else done := true;
    until done;
    ftrim := s;
  end;

{ ripped from xdoor and modified to use command buffer and tab comp }
Function  ddInstr(defString: String; Len: Byte): String;
 Var S, s2 : String;
     fPiece : string;
     I: Byte;
    Ch: Char;
    cp: byte; { x cursor pos }
    sx,sf,sb, curBuf : byte;
{    dirInfo : searchRec; }
  procedure tabComp(var cmdLine : string);
    var dirInfo : searchRec;
        s : string;
    begin;
      s := getToken(cmdLine, ' ', numToken(cmdLine, ' '));
      delete(cmdLine, pos(s, cmdLine), length(cmdLine));
      fPiece := s;
      if (pos('.', fPiece) = 0) then
        findFirst(fPiece + '*.*', anyfile, dirInfo)
      else
        findFirst(fPiece + '*', anyfile, dirInfo);
      if (dosError = 0) then s := dirInfo.name;
      findNext(dirInfo);
      if (dosError = 0) then begin
        nl;
        coutln(s);
        while (dosError = 0) do begin
          coutln(dirInfo.name);
          findNext(dirInfo);
        end;
        drawPrompt;
        s := fPiece;
      end;
      cmdLine := cmdLine + s;
    end;

  Begin
    sf := curfg;
    sb := curbg;
    sx := wherex;
    curBuf := 16;
    S := defString;
    cp := 1;
    if length(s) > len then delete(s,len+1,length(s));
    SaveCursor;
    cClrEol;
    RestoreCursor;
    Out(s);
    cp := length(s)+1;

    Repeat
      Ch := inKey;

      if (hitUp) then begin
        if (curBuf > 1 ) then begin
          dec(curBuf);
          if (ddCmdBuf[curBuf] <> '') then begin
            s := ddCmdBuf[curBuf];
            setPosX(sx);
            SaveCursor;
            cClrEol;
            RestoreCursor;
            Out(s);
            cp := length(s)+1;
          end
          else inc(curBuf);
        end;
      end
      else if (hitdown) then begin
        if (curBuf < 16) then begin
          inc(curBuf);
          if (curBuf = 16) then s := ''
          else s := ddCmdBuf[curBuf];
          setPosX(sx);
          SaveCursor;
          cClrEol;
          RestoreCursor;
          Out(s);
          cp := length(s)+1;
        end;
      end;

      If (HitLeft) and (cp > 1) Then Begin
        PosLeft(1);
        dec(cp);
      End;

      if (HitRight) and (Cp < length(s)+1) then Begin
        PosRight(1);
        inc(cp);
      End;

      If (HitDel) Then Begin
        savecursor;
        Delete(s,cp,1);
        if cp <> len then out( copy(s,cp, length(s) ) + #32 );
        restorecursor;
      End;

      If (HitHome) Then Begin
        PosLeft(cp-1);
        cp := 1;
      End;

      If (HitEnd) Then Begin
        PosRight(length(s)-cp+1);
        cp := length(s)+1;
      End;

      Case Ch of
       #8: If cp > 1 then begin
            out(#8); out(#32); out(#8);
            dec(cp);
            delete(s,cp,1);
            savecursor;
             if cp <> len then out( copy(s,cp,length(s))+#32 );
            restorecursor;
            end;
       #9: if (ftrim(s) <> '') then begin { tab completion }
             tabComp(s);
             setPosX(sx);
             SaveCursor;
             cClrEol;
             RestoreCursor;
             Out(s);
             cp := length(s)+1;
           end;

       #32..#126,#128..#254: If length(s) < len then begin
                              out(ch);
                              insert(ch,s,cp);
                              inc(cp);
                              if cp <> succ(length(s)) then begin
                                savecursor;
                                out( copy(s,cp,length(s) ) );
                                restorecursor;
                                end;
                              End;
       ^Y: Begin
            PosLeft(cp-1);
            SaveCursor;
            For I := 1 to Len Do Out(#32);
            RestoreCursor;
            S := '';
            cp := 1;
           End;

       End; { case }

    Until (Ch = #13) or (Ch = #27);

    if ch = #27 then s := defstring;

    nl;
    ddInstr := S; { this should be last line }
  End;

end.

